<template>
    <div class="px-2">
        <div class="card bg-transparent" style="min-height: 4rem;">
            <div class="card-body">
                <h3 class="card-title">Deposit To Advertiser</h3>

                <form>
                    <div class="form-group">
                        <label for="email">Email</label>
                        <input type="email" v-model="email" v-bind:class="['form-control',  {'is-invalid' : validationError && validationError.email}]" id="email" placeholder="Eg: someadvertiser@email.com">

                        <template v-if="validationError && validationError.email">
                            <span class="invalid-feedback">
                                <strong>{{ validationError.email[0] }}</strong>
                            </span>
                        </template>
                    </div>

                    <div class="form-group">
                        <label for="email">Amount</label>
                        <input type="number" v-model="amount" v-bind:class="['form-control',  {'is-invalid' : validationError && validationError.amount}]" id="amount" placeholder="Eg: 10">

                        <template v-if="validationError && validationError.amount">
                            <span class="invalid-feedback">
                                <strong>{{ validationError.amount[0] }}</strong>
                            </span>
                        </template>
                    </div>

                    <div class="alert alert-success" v-if="success">
                        {{ success.message }}
                        <button type="button" class="close" v-on:click.prevent="success = '';" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>

                    <div class="alert alert-danger" v-if="fail">
                        {{ fail.message }}
                        <button type="button" class="close" v-on:click.prevent="fail = '';" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>

                    <button type="submit" class="btn btn-primary" v-if="loading" disabled><i class="fas fa-spinner fa-spin"></i> DEPOSIT</button>
                    <button type="submit" class="btn btn-primary" v-else v-on:click.prevent="deposit">DEPOSIT</button>
                </form>
            </div>
        </div>
    </div>
</template>

<script>
    export default {
        data: function () {
            return {
                // Form
                email: '',
                amount: '',

                // Validation Error
                validationError: null,

                // Loading Flag
                loading: false,

                // Status flags
                success: false,
                fail: false,

            }
        },
        methods: {
            deposit: function () {
                // Show the loading
                this.loading = true;

                // Clear previous status messages
                this.success = false;
                this.fail = false;
                this.validationError = null;

                // Make a request to the api
                axios.post('/api/admin/advertiser/deposit', { 'email' : this.email, 'amount' : this.amount })
                    .then(response => {
                        this.success = {
                            'message': 'Deposit Successful'
                        };
                    })
                    .catch(error => {
                        if (error.response) {
                            // The request was made and the server responded with a status code
                            // that falls out of the range of 2xx
                            console.log(error.response.status);

                            // Handle validation errors
                            if (error.response.status === 422) {
                                this.validationError = error.response.data.errors;
                            } else if (error.response.status === 404) {
                                this.validationError = {
                                    'email' : ['Advertiser Not Found.']
                                };
                            } else if(error.response.status === 403) {
                                this.fail = {
                                    message: 'You are not allowed to add a new ad unit to this content.'
                                };
                            } else {
                                this.fail = {
                                    message: error.response.stats + ' Something went wrong.'
                                };
                            }

                        } else if (error.request) {
                            // The request was made, but no response was received
                            console.log(error.request);

                            this.fail = {
                                message: 'Check your connection and try again.'
                            };

                        } else {
                            // Something happened in setting up the request that triggered an error
                            console.log('Error', error.message);

                            this.fail = {
                                message: 'Something went wrong. Please Try Again'
                            };
                        }
                    })
                    .then(e => {
                        // Hide the loading
                        this.loading = false;
                    });
            }
        },
        mounted() {
            console.log('Admin - Home mounted.');
        }
    }
</script>
